﻿////////////////////////////////////////////////////////////////////////
// Модуль BatchDetails
////////////////////////////////////////////////////////////////////////
var BatchDetails = (function () {
    ///////////////////////////////////////////////////////
    var batchEventTable = null;
    ///////////////////////////////////////////////////////
    var BatchStatus = {
        New: 0,
        InProgress: 1,
        Done: 2,
        Finished: 3,
        Failed: 4
    };
    ///////////////////////////////////////////////////////
    var BatchEventColumns = {
        date: 0,
        event_type: 1,
        event_type_text: 2,
        event_type_color: 3,
        description: 4
    };
    ///////////////////////////////////////////////////////
    var showProgress = function (container) {
        $(container + " #spinner").show();
        $(container + " #error").hide();
        $(container + " #result").hide();
    };
    ///////////////////////////////////////////////////////
    var showResult = function (container, message) {
        $(container + " #spinner").hide();
        $(container + " #error").hide();
        $(container + " #result").html('<h3>' + message + ' </h3>');
        $(container + " #result").show();
    };
    /////////////////////////////////////////////////////////////////////
    var showError = function (container, message) {
        $(container + " #spinner").hide();
        $(container + " #error").html('<h3><span class=\"error\"> ' + message + ' </span></h3>');
        $(container + " #error").show();
    }; 

    var linkedProductionItems = function () {
        var linkedProductsTable = $('#linkedProductsTable').dataTable({
            "bDestroy": true,
            deferRender: true,
            scrollY: 115,
            scrollCollapse: true,
            scroller: true,
            "bProcessing": true,
            "bFilter": false,
            "bPaginate": false,
            "bInfo": false,
            "autoWidth": false
        });
    };

    var init = function () {
        
        $("#btnCollapseExpand").click(function () {
            var collapsed = $("#collapseAll").val();
            if (collapsed == 1) {
                $("#btnCollapseExpand").html("Свернуть");
                $("#collapseAll").val(0);
            } else {
                $("#btnCollapseExpand").html("Развернуть");
                $("#collapseAll").val(1);
            }

            $("#batchForm .showhide").each(function () {
                $(this).click();
            });
        });


        $('.panel-heading').on('click', function (event) {
            event.stopPropagation();
            $(this).find(".showhide").click();
        });

        // свернуть панели
        $("#divBatchEvents .showhide").click();

        // загрузить таблицу продукции
        linkedProductionItems();

        // загрузить таблицу связанных объектов
        LinkedTables.load($("#batch_id").val(), $("#LoadLinkedTablesAjax").val());
    };

    return {
        init:init
    };

})();

///////////////////////////////////////////////////////
$(document).ready(function () {

    BatchDetails.init();

});