﻿////////////////////////////////////////////////////////////////////////
// Модуль CaseAddChild
////////////////////////////////////////////////////////////////////////
var CaseAddChild = (function () {

    var ChildType = {
        Packet: 0,
        Wrapper: 1
    };

    var child_type = null;

    var addChildCallback = null;

    var eventAddChild = function (cb) {
        addChildCallback = cb;
    };


    var onSerialNumberReceived = function (serial) {
        $('#addChildModal').modal('hide');
        if (addChildCallback != null) {
            addChildCallback(serial);
        }        
    };

    var onAddClick = function () {
        $("#addChildModal #btnAdd").click(function () {
            onSerialNumberReceived($('#child_serial').val());
            $('#child_serial').val("");
        });
    };

    var onCancelClick = function () {
        $("#addChildModal #btnCancel").click(function () {
            $('#addChildModal').modal('hide');
            $('#child_serial').val("");
        });
    };

    var onSelectClick = function () {
        $("#addChildModal #btnSelect").click(function () {
            $('#addChildModal').modal('hide');
            $('#child_serial').val("");

            if (child_type == ChildType.Packet) {

                CaseSns.show();

            } else if (child_type == ChildType.Wrapper) {

                CaseWrappers.show();
            }

            
        });
    };

    var init = function (type) {

        child_type = type;

        CaseSns.init();
        CaseWrappers.init();

        if (child_type == ChildType.Packet) {

            CaseSns.eventSelected(onSerialNumberReceived);

        } else if (child_type == ChildType.Wrapper) {

            CaseWrappers.eventSelected(onSerialNumberReceived);
        }

        onAddClick();

        onCancelClick();

        onSelectClick();
    };

    return {
        init: init,
        eventAddChild: eventAddChild
    }

})();

