﻿////////////////////////////////////////////////////////////////////////
// Модуль PalletCases
////////////////////////////////////////////////////////////////////////
var CaseWrappers = (function () {

    var selectedCallback = null;
    var eventSelected = function (cb) {
        selectedCallback = cb;
    };

    ///////////////////////////////////////////////////////////////////////////////
    var table = null;
    ///////////////////////////////////////////////////////////////////////////////
    var callback = null;
    ///////////////////////////////////////////////////////////////////////////////
    var Columns = {
        create_date: 0,
        batch_serial: 1,
        serial: 2,
        child_amount: 3,
        status: 4,
        status_color: 5,
        action: 6
    };

    var selected = function (serial) {
        $('#wrapperModal').modal('hide');

        if (selectedCallback != null) {
            selectedCallback(serial);
        }
    };

    //////////////////////////////////////////////////////////////////////////////
    var loadTable = function () {

        $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

        popUpShowProgress("#wrapperModal");

        $('#wrapperModal').modal('show');

        var url = $("#GetWrappersPrintedOnlyAjax").val();

        var batch_id = $("#batch_id").val();

        table = $('#wrapperTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                type: "post",
                data: {
                    batch_id: batch_id
                },
                complete: function () {
                    $("#wrapperModal .modal-dialog").stop(true, true);
                    $("#wrapperModal .modal-dialog").animate({ "width": "1000px" }, 300, 'linear');
                    popUpShowResults("#wrapperModal");
                }
            },
            "bDestroy": true,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "order": [[0, "desc"]],
            "columnDefs": [
                {
                    "width": "120",
                    render: function (data, type, full, meta) {
                        return "<div class='text-nowrap'>" + data + "</div>";
                    },
                    targets: Columns.create_date
                },
                {
                    render: function (data, type, full, meta) {
                        return "<div class='hor-mid'>" + full[Columns.child_amount] + "</div>";
                    },
                    targets: Columns.child_amount
                },
                {
                    render: function (data, type, full, meta) {
                        var status_color = full[Columns.status_color];
                        return "<div class='hor-mid list-status-box " + status_color + "'>" + data + "</div>";
                    },
                    targets: Columns.status
                },
                {
                    "targets": Columns.status_color,
                    "visible": false,
                    "searchable": false
                },
                {
                    "width": "90",
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        return "<div class=\"dropdown hor-mid\">" +
                                        "<a onclick=\"CaseWrappers.selected('" + data[Columns.serial] + "')\" class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                            "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                        "</a>" +
                                    "</div>";
                    }
                }
            ]
        });
    };

    var show = function () {

        loadTable();
    };

    var init = function () {     

        $('#wrapperModal').on('hidden.bs.modal', function () {
            $("#wrapperModal .modal-dialog").stop(true, true);
            $("#wrapperModal .modal-dialog").animate({ "width": "500px" }, 100, 'linear');
        });
    };

    return {
        init: init,
        eventSelected: eventSelected,
        show: show,
        selected: selected
    };
})();
///////////////////////////////////////////////////////////////////////////////
