﻿////////////////////////////////////////////////////////////////////////
// Модуль PacketDetails
////////////////////////////////////////////////////////////////////////
var PacketDetails = (function () {
    //////////////////////////////////////////////////////////////////////////////////
    var checkStatus = function () {
        var status = $("#status").val();
        if (status == PackageStatus.Aggregated) {
            showItem("#btnRetrieve");
        } else {
            hideItem("#btnRetrieve");
            hideItem("#divParent");
        }
    };
    /////////////////////////////////////////////////////////////////////
    var collapseExpand = function () {
        $("#btnCollapseExpand").click(function () {
            var collapsed = $("#collapseAll").val();
            if (collapsed == 1) {
                $("#btnCollapseExpand").html("Свернуть");
                $("#collapseAll").val(0);
            } else {
                $("#btnCollapseExpand").html("Развернуть");
                $("#collapseAll").val(1);
            }

            $("#snForm .showhide").each(function () {
                $(this).click();
            });
        });
    };

    var onRetrieveClick = function () {
        $('#btnRetrieve').click(function () {
            var serial = $("#serial").val();
            $('#confirmModal #info').html('Извлечь упаковку № ' + serial + '?');
            $('#confirmModal').modal('show');
        });
    };
    var onConfirmClick = function () {
        $('#confirmModal #btnConfirm').click(function () {
            var url = $("#RetrieveAjax").val();
            var id = $("#id").val();

            $.post(url, {
                id: id
            })
          .done(function (data) {
              if (data != null && data != '') {

                  if (data.Result == true) {

                      $('#confirmModal').modal('hide');

                      // обновить статус
                      if (data.Item != null) {

                          $("#status").val(data.Item.status);
                          $("#status_text").text(data.Item.status_text);
                          $("#status_text").removeClass();
                          $("#status_text").addClass("control-label status-box ");
                          $("#status_text").addClass(data.Item.status_color);

                          checkStatus();

                          LinkedTables.load(id, $("#LoadLinkedTablesAjax").val());

                          toastr.info("Упаковка извлечена");
                      }
                  }
                  else {
                      $('#confirmModal').modal('hide');
                      toastr.error(data.Description, "Ошибка!");
                  }
              }
              else {
                  $('#confirmModal').modal('hide');
                  toastr.error("Невозможно выполнить операцию", "Ошибка!");
              }
          })
          .fail(function () {
              toastr.error("Невозможно выполнить операцию", "Ошибка!");
          });
        });
    };
    /////////////////////////////////////////////////////////////////////////
    var onSerialNumberReceived = function (serial) {
        var url = $("#GetPackageUrlAjax").val();
        $.post(url, {
            serial: serial
        })
         .done(function (data) {
             if (data != null && data != '' && data.Result == true) {
                 window.location.href = data.url;
             }
         })
         .fail(function () {
             toastr.error("Невозможно выполнить операцию", "Ошибка!");
         });
    };
    ////////////////////////////////////////////////////////////////////
    var init = function () {

        collapseExpand();

        onRetrieveClick();

        onConfirmClick();

        LinkedTables.load($("#id").val(), $("#LoadLinkedTablesAjax").val());

        $('.panel-heading').on('click', function (event) {
            event.stopPropagation();
            $(this).find(".showhide").click();
        });               

        // закрыть окно без подтверждения действие
        $('#confirmModal #btnCancel').click(function () {
            $('#confirmModal').modal('hide');
        });

        // актуализация полей в соответствии со статусом
        checkStatus();

        Scanner.eventSerialNumber(onSerialNumberReceived);

    };

    return {
        init: init
    };

})();

//////////////////////////////////////////////////////////////////////////////////
$(document).ready(function () {

    PacketDetails.init();

});
