﻿////////////////////////////////////////////////////////////////////////
// Модуль PacketModal
////////////////////////////////////////////////////////////////////////
var PacketModal = (function () {

    var selectedCallback = null;

    ///////////////////////////////////////////////////////////////////////////////
    var table = null;
    ///////////////////////////////////////////////////////////////////////////////
    var callback = null;
    ///////////////////////////////////////////////////////////////////////////////
    var Columns = {
        create_date: 0,
        batch_serial: 1,
        serial: 2,
        child_amount: 3,
        status: 4,
        status_color: 5,
        action: 6
    };

    var selected = function (serial) {
        $('#snModal').modal('hide');

        if (selectedCallback != null) {
            selectedCallback(serial);
        }
    };
    ///////////////////////////////////////////////////////////////////////////////
    var hide = function () {
        $('#snModal').modal('hide');
    };
    //////////////////////////////////////////////////////////////////////////////


    var getDataMatrixImage = function (id, type) {
        var url = $("#GetDataMatrixImageAjax").val();

        var result;
        $.ajax({
            url: url,
            type: "POST",
            async: false,
            data: 'id=' + id + '&type=' + type,
            dataType: 'json',
            success: function (data) {
                if (data != null && data != '') {
                    if (data.Result == true) {
                        console.info(data.Description);
                        result = data;
                    } else {
                        console.error(data.Description);
                    }
                }
            }
        });

        return result;
    }



    var loadTable = function (batch_id) {

        $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

        popUpShowProgress("#snModal");

        $('#snModal').modal('show');

        var url = $("#GetSnsPrintedOnlyAjax").val();

        table = $('#snTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                type: "post",
                data: {
                    batch_id: batch_id
                },
                complete: function () {
                    $("#snModal .modal-dialog").stop(true, true);
                    $("#snModal .modal-dialog").animate({ "width": "1000px" }, 300, 'linear');
                    popUpShowResults("#snModal");
                }
            },
            "bDestroy": true,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "order": [[0, "desc"]],
            "columnDefs": [
                {
                    "width": "120",
                    render: function (data, type, full, meta) {
                        return "<div class='text-nowrap'>" + data + "</div>";
                    },
                    targets: Columns.create_date
                },
                {
                    render: function (data, type, full, meta) {
                        return "<div class='hor-mid'>" + full[Columns.child_amount] + "</div>";
                    },
                    targets: Columns.child_amount
                },
                {
                    render: function (data, type, full, meta) {
                        var status_color = full[Columns.status_color];
                        return "<div class='hor-mid list-status-box " + status_color + "'>" + data + "</div>";
                    },
                    targets: Columns.status
                },
                {
                    "targets": Columns.status_color,
                    "visible": false,
                    "searchable": false
                },
                {
                    "width": "90",
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {

                        if (StorekeeperArea) {
                            var serial = data[Columns.serial];

                            var dataCode = getDataMatrixImage(serial, "SelectItem");

                            return "<div class=\"dropdown hor-mid\">" +
                                "<button name=\"" +
                                dataCode.name +
                                "\" class=\"btn btn-stock-table-item dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\" onclick=\"PacketModal.selected('" + data[Columns.serial] + "')\">" +
                                "<img class=\"data-matrix-stock-table-button\" src=\"data:image/png;base64," +
                                dataCode.code +
                                "\">" +
                                "</button>" +
                                "</div>";
                        } else {

                            return "<div class=\"dropdown hor-mid\">" +
                                "<a onclick=\"PacketModal.selected('" + data[Columns.serial] + "')\" class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                "</a>" +
                                "</div>";
                        }


                    }
                }
            ]
        });
    };

    var show = function (batch_id) {

        loadTable(batch_id);
    };

    var init = function (callback) {
        selectedCallback = callback;
        $('#snModal').on('hidden.bs.modal', function () {
            $("#snModal .modal-dialog").stop(true, true);
            $("#snModal .modal-dialog").animate({ "width": "500px" }, 100, 'linear');
        });
    };

    return {
        init: init,
        show: show,
        selected: selected,
        hide: hide
    };
})();
///////////////////////////////////////////////////////////////////////////////
