﻿////////////////////////////////////////////////////////////////////////
// Модуль PalletList
////////////////////////////////////////////////////////////////////////
var PalletList = (function () {
    
    var palletTable = null;
    ////////////////////////////////////////////////////////////////////////
    var Columns = {
        create_date: 0,
        batch_serial: 1,
        serial: 2,
        child_amount: 3,
        status: 4,
        status_color: 5,
        action: 6
    };
    /////////////////////////////////////////////////////////////////////
    var showHideFilter = function () {
        var show_filter = $('#show_filter').val();
        if (show_filter == 'true') {
            $('#divFilter').show();
        } else {
            $('#divFilter').hide();
        }

        var batch_id = $("#batch_id").val();
        loadPalletTable(batch_id, null, null, null, null, null, null);
    };
    /////////////////////////////////////////////////////////////////////
    var loadPalletTable = function (batch_id, batch_serial, sn, status, filter_date, product_gtin, product_name) {
        // очистить таблицу
        if (palletTable != null) {
            palletTable.api().clear();
        }

        $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');
        var url = $("#GetListAjax").val();
        palletTable = $('#palletTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                    type: "POST",
                data: {
                    batch_id: batch_id,
                    batch_serial: batch_serial,
                    sn: sn,
                    status: status,
                    filter_date: filter_date,
                    product_gtin: product_gtin,
                    product_name: product_name
                }
            },
            "bDestroy": true,
            "autoWidth": false,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "order": [[0, "desc"]],
            "columnDefs": [
                {
                    "width": "120",
                    render: function (data, type, full, meta) {
                        return "<div class='text-nowrap'>" + data + "</div>";
                    },
                    targets: Columns.create_date
                },
                {
                    render: function (data, type, full, meta) {
                        var status_color = full[Columns.status_color];
                        return "<div class='hor-mid list-status-box " + status_color + "'>" + data + "</div>";
                    },
                    targets: Columns.status
                },
                {
                    render: function (data, type, full, meta) {
                        return "<div class='hor-mid'>" + data + "</div>";
                    },
                    targets: Columns.child_amount
                },
                {
                    "targets": [Columns.status_color],
                    "visible": false,
                    "searchable": false
                },
                {
                    "width": "90",
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        var url = $("#viewDetailsUrl").val() + "/" + data[Columns.action];
                        return "<div class=\"dropdown hor-mid\">" +
                                        "<a href='" + url + "' onClick=\"window.location.href ='" + url + "'\" class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Детализация\" data-toggle=\"dropdown\">" +
                                            "<i class=\"fa fa-eye table-icons-big\"></i>" +
                                        "</a>" +
                                    "</div>";
                    }
                }
            ]
        });
    };
    /////////////////////////////////////////////////////////////////////
    var onCreateClick = function () {
        $("#btnCreate").click(function () {
            PalletSelectBatch.show();
        });
    };
    /////////////////////////////////////////////////////////////////////
    var batchSelected = function (batch_serial) {
        var url = $("#CreateAjax").val();
        $.post(url,
                {
                    batch_serial: batch_serial
                })
                .done(function (data) {
                    if (data.Result == true) {
                        window.location.href = $("#viewDetailsUrl").val() + "/" + data.Id;
                    } else {
                        toastr.error(data.Description, "Ошибка!");
                    }
                })
                .fail(function () {
                    toastr.error("Ошибка подключения. Обновите страницу.");
                });
    };
    /////////////////////////////////////////////////////////////////////////
    var onSerialNumberReceived = function (serial) {
        var url = $("#GetPackageUrlAjax").val();
        $.post(url, {
            serial: serial
        })
         .done(function (data) {
             if (data != null && data != '' && data.Result == true) {
                 window.location.href = data.url;
             }
         })
         .fail(function () {
             toastr.error("Невозможно выполнить операцию", "Ошибка!");
         });
    };
    /////////////////////////////////////////////////////////////////////
    var init = function () {

        onCreateClick();

        PalletSelectBatch.init();

        PalletSelectBatch.eventSelectBatch(batchSelected);


        $("#filter_date").datepicker({
            format: 'dd.mm.yyyy',
            language: 'ru'
        });

        showHideFilter();

        ////////////////////////////////////////////////////////////////////////
        $("#btnFilter").click(function () {
            if ($('#show_filter').val() == 'true') {
                $('#show_filter').val('false');
            } else {
                $('#show_filter').val('true');
            }

            showHideFilter();

            $('#batch_serial').val("");
            $('#serial').val("");
            $('#filter_date').val("");
            $('#product_gtin').val("");
            $('#product_name').val("");

        });
        ////////////////////////////////////////////////////////////////////////
        $("#btnApplyFilter").click(function () {
            var batch_serial = $('#batch_serial').val();
            var sn = $('#serial').val();
            var status = $('#status_list :selected').val();
            var filter_date = $('#filter_date').val();
            var batch_id = $("#batch_id").val();
            var product_gtin = $("#product_gtin").val();
            var product_name = $("#product_name").val();

            loadPalletTable(batch_id, batch_serial, sn, status, filter_date, product_gtin, product_name);
        });

        Scanner.eventSerialNumber(onSerialNumberReceived);
    };

    return {
        init: init
    };

})();
////////////////////////////////////////////////////////////////////////
$(function () {

    PalletList.init();
    
});