﻿
var BatchesColumns = {
    created: 0,   
    user_login: 1,
    batch_serial: 2,
    product_gtin: 3,
    product_name: 4,
    sn_amount: 5,
    batch_id: 6
}

$(function () {

    $.fn.dataTable.moment('dd.MM.yyyy HH:mm:ss');

    $('#btnGetBatchFromList').on('click', function () {
        var url = $("#GetBatchListAjax").val();

        var table = $('#batchTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "bDestroy": true,
            "lengthMenu": [[5, 10, 50], [5, 10, 50]],
            "ajax": {
                url,
                type: "post",
                complete: function () {
                    $('#batchesModal').modal('show');
                }
            },
            "bServerSide": true,
            "bProcessing": true,
            "order": [[0, "asc"]],
            "columnDefs": [
                {
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        var batch_id = full[BatchesColumns.batch_id];
                        var batch_serial = full[BatchesColumns.batch_serial];
                        var product_name = full[BatchesColumns.product_name];
                        var sn_amount = full[BatchesColumns.sn_amount];
                        return "<div class=\"dropdown hor-mid\">" +
                                    "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                    "</a>" +
                                "</div>";
                    }
                }
            ],
            initComplete: function () {
                var api = this.api();
                $('#batchTable_filter input')
                    .off('.DT')
                    .on('keyup.DT', function (e) {
                        if (e.keyCode === 13 || this.value.length === 0) {
                            api.search(this.value).draw();
                        }
                    });
            }
        });

        $('#batchTable tbody').on('click', 'a', function () {
            var data = table.api().row($(this).parents('tr')).data();
            var batch_id = data[BatchesColumns.batch_id];
            var batch_serial = data[BatchesColumns.batch_serial];
            var product_name = data[BatchesColumns.product_name];
            var sn_amount = data[BatchesColumns.sn_amount];

            $('#batchesModal').modal('hide');
            $('#batch_id').val(batch_id);
            $('#batch_serial').val(batch_serial);
            $('#product_name').val(product_name);
            $('#sn_amount').val(sn_amount);
        });
    });    
});