﻿/////////////////////////////////////////////////////////////////////
var ReloadColumns = {
    status_text: 0,
    status: 1,
    status_color: 2,
    progress: 3,
    batch_serial: 4,
    id: 5
}
/////////////////////////////////////////////////////////////////////
var Columns = {
    id: 0,
    create_date: 1,
    product_name: 2,
    product_gtin: 3,
    sn_amount: 4,
    equipment_name: 5,
    equipment_id: 6,
    batch_serial: 7,
    status_text: 8,
    status: 9,
    status_color: 10,
    progress: 11,
    action: 12
}
/////////////////////////////////////////////////////////////////////
var Status = {
    New: 0,
    Enqueued: 1,
    Generation: 2,
    InProgress: 3,
    Done: 4,
    Failed: 5,
    Finished: 6,
    Interrupted: 7,
    Preparation: 8,
    Loading: 9,
    Aggregation: 10,
    Starting: 11,
    ConnectionLost: 12
}
/////////////////////////////////////////////////////////////////////
var ProductionEventColumns = {
    date: 0,
    event_type: 1,
    event_type_text: 2,
    event_type_color: 3,
    description: 4
}
/////////////////////////////////////////////////////////////////////
var showError = function (container, message) {
    $(container + " #spinner").hide();
    $(container + " #error").html('<h3><span class=\"error\"> ' + message + ' </span></h3>');
    $(container + " #error").show();
}
/////////////////////////////////////////////////////////////////////
var showResult = function (container, message) {
    $(container + " #spinner").hide();
    $(container + " #error").hide();
    $(container + " #result").html('<h3>' + message + ' </h3>');
    $(container + " #result").show();
}
/////////////////////////////////////////////////////////////////////
var showDetails = function (container, message) {
    $(container + " #spinner").hide();
    $(container + " #error").hide();
    $(container + " #result").html(message);

    $(container + " #result").show();

    $(container + " .animate-panel").animatePanel();
}
/////////////////////////////////////////////////////////////////////
var showProgress = function (container) {
    $(container + " #spinner").show();
    $(container + " #error").hide();
    $(container + " #result").hide();
}
/////////////////////////////////////////////////////////////////////
var hideAll = function (container) {
    $(container + " #spinner").hide();
    $(container + " #error").hide();
    $(container + " #result").hide();
}
/////////////////////////////////////////////////////////////////////
var gtin2articleLoad = function (gtin) {
    var url = $("#Gtin2ArticleLoadAjax").val();
    if (gtin) {
        $.post(url, {
            gtin: gtin
        })
            .done(function (data)
            {
                if (!$("#equipment_name").val() && !$("#equipment_id").val() && !$('#article').val())
                if (data.equipment_id && data.equipment_name) {
                    if (!$("#equipment_name").val()) $("#equipment_name").val(data.equipment_name);
                    if (!$("#equipment_id").val()) $("#equipment_id").val(data.equipment_id);

                    var articleDDL = $("#article");
                    articleDDL.html("");
                    $.each(data.article_list, function () {
                        articleDDL.append($("<option />").val(this).text(this));
                    });

                    $("#article option[value=\"" + data.article + "\"]").prop('selected', true);
                } else {
                    $("#equipment_name").val("");
                    $("#equipment_id").val("");
                    $("#article").html("");
                }
            })
            .fail(function () {
                // do nothing
            });
    }
}

/////////////////////////////////////////////////////////////////////
$(document).ready(function () {
    $('#redirectToBatch').on('click',
        function (e) {
            if (!$('#batch_serial').val()) {
                e.preventDefault();
                window.location.href = "/Operator/Production";
            }
        });

    //////////////////////////////////////////////////////////////
    $("#btnStopStatusCloseModal").click(function () {
        $('#stopStatusModal').modal('hide');
    });

    // close the modal window and redirect to the production index if success
    $("#btnCloseProductionModal").click(function () {
        $('#startProductionModal').modal('hide');
        if ($("#startProductionModal #mode").val() == "details" &&
            $("#startProductionModal #success").val() == "true") {
            window.location.href = $("#targetUrl").val() + "/" + $("#id").val();
        } 
    });

    $("#btnCollapseExpand").click(function () {
        var collapsed = $("#collapseAll").val();
        if (collapsed == 1) {
            $("#btnCollapseExpand").html("Свернуть");
            $("#collapseAll").val(0);
        } else {
            $("#btnCollapseExpand").html("Развернуть");
            $("#collapseAll").val(1);
        }        

        $("#productionForm .showhide").each(function () {
            $(this).click();
        });
    });


    $('.panel-heading').on('click', function (event) {
        event.stopPropagation();
        $(this).find(".showhide").click();
    });

});