﻿////////////////////////////////////////////////////////////////////////
// Модуль ShipmentBatch
////////////////////////////////////////////////////////////////////////
var ProductionCounterparty = (function () {
    // таблица партий
    var table = null;

    // поля таблицы
    var Columns = {
        name: 0,
        address: 1,
        inn: 2,
        identifier: 3,
        kpp : 4,
        id: 5
    };

    // управление показом фильтра
    var showHideFilter = function () {
        var show_filter = $('#show_counterparty_filter').val();
        if (show_filter == 'true') {
            $('#divCounterpartyFilter').show();
        } else {
            $('#divCounterpartyFilter').hide();
        }
        loadTable(null, null, null, null, null);
    };

    // загрузка таблицы партий
    var loadTable = function (filter_name, filter_address, filter_inn, filter_identifier, filter_kpp) {

        var url = $("#GetCounterpartyListAjax").val();

        popUpShowProgress("#counterpartyModal");

        $('#counterpartyModal').modal('show');

        table = $('#counterpartyTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                    type: "POST",
                    data: {
                        filter_name: filter_name,
                        filter_address: filter_address,
                        filter_inn: filter_inn,
                        filter_identifier: filter_identifier,
                        filter_kpp : filter_kpp
                    },
                    complete: function () {
                        $("#counterpartyModal .modal-dialog").stop(true, true);
                        $("#counterpartyModal .modal-dialog").animate({ "width": "1000px" }, 300, 'linear');
                        popUpShowResults("#counterpartyModal");
                    }

            },
            "bDestroy": true,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "autoWidth": false,
            "order": [[0, "asc"]],
            "columnDefs": [
                {
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        return "<div class=\"dropdown hor-mid\">" +
                                        "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                            "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                        "</a>" +
                                    "</div>";
                    }
                }
            ]
        });

        // обрабочик нажатия на строку таблицы
        $('#counterpartyTable tbody').on('click', 'a', function () {
            var data = table.api().row($(this).parents('tr')).data();

            $('#customer_name').val(data[Columns.name]);
            $('#customer_address').val(data[Columns.address]);
            $('#customer_inn').val(data[Columns.inn]);
            $('#customer_identifier').val(data[Columns.identifier]);
            $('#customer_kpp').val(data[Columns.kpp]);
            $('#counterpartyModal').modal('hide');

            scrollTo("divCustomerPanel");

        });
    };

    

    // инициализация модуля
    var init = function () {

        $('#counterpartyModal').on('hidden.bs.modal', function () {
            popUpHideAll("#counterpartyModal");
        });

        $('#counterpartyModal').on('hidden.bs.modal', function () {
            $("#counterpartyModal .modal-dialog").stop(true, true);
            $("#counterpartyModal .modal-dialog").animate({ "width": "500px" }, 100, 'linear');
        });

        $('#btnCounterparty').on('click', function () {          

            showHideFilter();
        });

        $("#btnCounterpartyApplyFilter").click(function () {
            var filter_name = $('#filter_name').val();
            var filter_address = $('#filter_address').val();
            var filter_inn = $('#filter_inn').val();
            var filter_identifier = $('#filter_identifier').val();
            var filter_kpp = $('#filter_kpp').val();

            loadTable(filter_name, filter_address, filter_inn, filter_identifier, filter_kpp);
        });

        $("#btnCounterpartyFilter").click(function () {
            if ($('#show_counterparty_filter').val() == 'true') {
                $('#show_counterparty_filter').val('false');
            } else {
                $('#show_counterparty_filter').val('true');
            }
            showHideFilter();

            // очистить фильтр
            $('#filter_name').val("");
            $('#filter_address').val("");
            $('#filter_inn').val("");
            $('#filter_identifier').val("");
            $('#filter_kpp').val("");

        });
    };

    // экспорт функций, доступных за пределами модуля
    return {
        init: init
    };
})();
///////////////////////////////////////////////////////////////////////////////