﻿/////////////////////////////////////////////////////////////////////////////////////////////////////
var OrderColumns = {
    gtin: 0,
    name: 1,
    shelf_life: 2,  
    amount: 3,
    id: 4,
    order_name: 5,
    order_date: 6
}
/////////////////////////////////////////////////////////////////////////////////////////////////////
$(document).ready(function () {

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    $('#ordersModal').on('hidden.bs.modal', function () {
        popUpHideAll("#ordersModal");
        $("#ordersModal .modal-dialog").stop(true, true);
        $("#ordersModal .modal-dialog").animate({ "width": "500px" }, 100, 'linear');
    });

    $('#btnOrders').on('click', function () {

        popUpShowProgress("#ordersModal");

        $('#ordersModal').modal('show');

        var url = $("#GetOrdersAjax").val();

        var table = $('#ordersTable').dataTable({
            language: {
                "url": $("#lang").val()
            },            
            "ajax": {
                url,
                type: "post"
            },
            "initComplete": function (settings, data) {
                if (data.errorMessage) {
                    popUpShowError("#ordersModal", data.errorMessage);
                }
                else if (table.api().data().count() > 0) {
                    $("#ordersModal .modal-dialog").stop(true, true);
                    $("#ordersModal .modal-dialog").animate({ "width": "800px" }, 300, 'linear');
                    popUpShowResults("#ordersModal");
                }
            },
            "bDestroy": true,
            "bFilter": false,
            "bPaginate": false,
            "bInfo": false,
            "bServerSide": true,
            "bProcessing": false,
            "order": [[0, "asc"]],
            "columnDefs": [
                {
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        return "<div class=\"dropdown hor-mid\">" +
                                    "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                    "</a>" +
                                "</div>";
                    }
                }
            ]
        });

        $('#ordersTable tbody').on('click', 'a', function () {
            var data = table.api().row($(this).parents('tr')).data();
            var gtin = data[OrderColumns.gtin];
            var quantity = data[OrderColumns.amount];
            var productName = data[OrderColumns.name];
            var storageLife = data[OrderColumns.shelf_life];
            var id = data[OrderColumns.id];
			var ordername = data[OrderColumns.order_name];
            var orderdate = data[OrderColumns.order_date];
			var date = new Date();
            var shelfDate = new Date();
            shelfDate.setDate(date.getDate() + parseInt(storageLife));
            let day = shelfDate.getDate().toString();
            if (day.length < 2) day = `0${day}`;
            let month = (shelfDate.getMonth() + 1).toString();
            if (month.length < 2) month = `0${month}`;
            var shelfString = `${day}.${month}.${shelfDate.getFullYear()}`;

            $("#product_gtin").val(gtin);
            $("#sn_amount").val(quantity);
            $("#product_name").val(productName);
            $("#product_shelf_life").val(storageLife);
            $("#from_erp").val('True').trigger('change');
            $("#from_erp_id").val(id);
            $('#product_shelf_date').val(shelfString);

            var externalName = "";
            if (ordername) {
                externalName = ordername.replace(/ /g, "_");
                if (orderdate) 
                    externalName = externalName + "_" + orderdate.replace(/ /g, "_");
            }

            if (externalName) {
                $("#generate_order_name").prop("checked", false);
                window.generateOrderName();
                $("#order_name").val(externalName);
            }

            $('#ordersModal').modal('hide');

            gtin2articleLoad(gtin);

        });

    });    
});