﻿////////////////////////////////////////////////////////////////////////
// Модуль RepackView
////////////////////////////////////////////////////////////////////////
var ProductionView = (function () {
    var mainLoop = null;

    var PackageType = {
        Wrapper: 1,
        Case: 2,
        Pallet: 3
    };
    ///////////////////////////////////////////////////////////////////////////////
    var updateButtons = function (status) {
    
        switch(parseInt(status))
        {
            case Status.New:
                {
                    // скрыть
                    hideItem("#btnContinueProduction");
                    hideItem("#btnStopProduction");
                    hideItem("#btnInterruptProduction");
                    hideItem("#addWrapper");
                    hideItem("#addCase");
                    hideItem("#addPallet");
                    // показать
                    showItem("#btnRestartProduction");
                    break;
                }
            case Status.Enqueued:
            case Status.Generation: 
            case Status.Preparation:
            case Status.Loading:
            case Status.Starting:
                {
                    // скрыть
                    hideItem("#btnContinueProduction");
                    hideItem("#btnRestartProduction");
                    hideItem("#btnInterruptProduction");
                    hideItem("#addWrapper");
                    hideItem("#addCase");
                    hideItem("#addPallet");
                    // показать
                    showItem("#btnStopProduction");
                    break;
                }
            case Status.Aggregation:
                {
                    // скрыть
                    hideItem("#btnContinueProduction");
                    hideItem("#btnRestartProduction");
                    hideItem("#btnInterruptProduction");
                    // показать
                    showItem("#btnStopProduction");
                    showItem("#addWrapper");
                    showItem("#addCase");
                    showItem("#addPallet");
                    break;
                }
            case Status.InProgress:
                {
                    // скрыть
                    hideItem("#btnRestartProduction");
                    hideItem("#btnContinueProduction");
                    // показать
                    showItem("#btnStopProduction");
                    showItem("#btnInterruptProduction");
                    showItem("#addWrapper");
                    showItem("#addCase");
                    showItem("#addPallet");
                    break;
                }
            case Status.Done:
                {
                    // скрыть
                    hideItem("#btnInterruptProduction");
                    hideItem("#btnContinueProduction");
                    hideItem("#btnRestartProduction");
                    // показать
                    showItem("#btnStopProduction");
                    showItem("#addWrapper");
                    showItem("#addCase");
                    showItem("#addPallet");
                    break;
                }
            case Status.ConnectionLost:
                {
                    // скрыть
                    hideItem("#btnInterruptProduction");
                    hideItem("#btnContinueProduction");
                    hideItem("#btnRestartProduction");
                    hideItem("#addWrapper");
                    hideItem("#addCase");
                    hideItem("#addPallet");
                    // показать
                    showItem("#btnStopProduction");
                    break;
                }
            case Status.Finished:
                {
                    // скрыть
                    hideItem("#btnInterruptProduction");
                    hideItem("#btnContinueProduction");
                    hideItem("#btnRestartProduction");
                    hideItem("#btnStopProduction");
                    hideItem("#addWrapper");
                    hideItem("#addCase");
                    hideItem("#addPallet");
        
                    if (!$("#divSnUnassignedPanel").hasClass('invisible')) {
                        $("#divSnUnassignedPanel").addClass('invisible')

                        hideItem("#divWrapperRest");
                        hideItem("#divCaseRest");
                        hideItem("#divPalletRest");
                    }
                    break;
                }
            case Status.Interrupted:
                {
                    // скрыть
                    hideItem("#btnRestartProduction");
                    hideItem("#btnInterruptProduction");
                    // показать            
                    showItem("#btnStopProduction");            
                    showItem("#btnContinueProduction");
                    showItem("#addWrapper");
                    showItem("#addCase");
                    showItem("#addPallet");
                    break;
                }
            case Status.Failed:
                {
                    // показать
                    showItem("#btnRestartProduction");
                    showItem("#btnStopProduction");
                    // скрыть
                    hideItem("#btnInterruptProduction");
                    hideItem("#btnContinueProduction");                    
                    hideItem("#addWrapper");
                    hideItem("#addCase");
                    hideItem("#addPallet");

                    break;
                }
        }
    }
    ///////////////////////////////////////////////////////////////////////////////
    var showErrorPanel = function (show) {
        if (show == true) {
            // показать панель с описание ошибки
            $('#lblErrorType').css("margin-top", ($('#error').height() / 2) - ($('#lblErrorType').height() / 2));
            $('#error_type').css("margin-top", ($('#error').height() / 2) - ($('#error_type').height() / 2));
            $('#lblErrorDescription').css("margin-top", ($('#error').height() / 2) - ($('#lblErrorDescription').height() / 2));
            
            showItem("#divProductionError");

        } else {
            // скрыть панель с описанием ошибки
            hideItem("#divProductionError");
            $('#error_type').val("");
            $('#error_text').html("");
        }
    }
    ///////////////////////////////////////////////////////////////////////////////
    var checkStatistics = function () {

        // отпечатанные SN
        var divSnOkValue = $("#divSnOkValue").text().trim();
        if (divSnOkValue != "0" && divSnOkValue != "-") {
            if (!$("#divSnOk div").hasClass("progress-bar")) {
                $("#divSnOk div").addClass("progress-bar");
            }
        }
        // упакованные SN
        var divSnPackedValue = $("#divSnPackedValue").text().trim();
        if (divSnPackedValue != "0" && divSnPackedValue != "-") {
            if (!$("#divSnPacked div").hasClass("progress-bar")) {
                $("#divSnPacked div").addClass("progress-bar");
            }
        }
        // бракованные SN
        var divSnNokValue = $("#divSnNokValue").text().trim();
        if (divSnNokValue != "0" && divSnNokValue != "-") {
            if (!$("#divSnNok div").hasClass("progress-bar")) {
                $("#divSnNok div").addClass("progress-bar");
            }
        }
        // неиспользованные SN
        var divSnUnassignedValue = $("#divSnUnassignedValue").text().trim();
        if (divSnUnassignedValue != "0" && divSnUnassignedValue != "-") {
            if (!$("#divSnUnassigned div").hasClass("progress-bar")) {
                $("#divSnUnassigned div").addClass("progress-bar");
            }
        }
        // бандероли
        var divWrapperOkValue = $("#divWrapperOkValue").text().trim();
        if (divWrapperOkValue != "0" && divWrapperOkValue != "-") {
            if (!$("#divWrapperOk div").hasClass("progress-bar")) {
                $("#divWrapperOk div").addClass("progress-bar");
            }
        }
        // гофрокоробы
        var divCaseOkValue = $("#divCaseOkValue").text().trim();
        if (divCaseOkValue != "0" && divCaseOkValue != "-") {
            if (!$("#divCaseOk div").hasClass("progress-bar")) {
                $("#divCaseOk div").addClass("progress-bar");
            }
        }
        // паллеты
        var divPalletOkValue = $("#divPalletOkValue").text().trim();
        if (divPalletOkValue != "0" && divPalletOkValue != "-") {
            if (!$("#divPalletOk div").hasClass("progress-bar")) {
                $("#divPalletOk div").addClass("progress-bar");
            }
        }
    }
    //////////////////////////////////////////////////////////////////////////////////////////////
    var finalize = function () {
        if ($("#divSnOk").hasClass('active')) $("#divSnOk").removeClass('active');
        if ($("#divSnPacked").hasClass('active')) $("#divSnPacked").removeClass('active');
        if ($("#divSnNok").hasClass('active')) $("#divSnNok").removeClass('active');
        if ($("#divSnUnassigned").hasClass('active')) $("#divSnUnassigned").removeClass('active');

        if ($("#divWrapperOk").hasClass('active')) $("#divWrapperOk").removeClass('active');
        if ($("#divCaseOk").hasClass('active')) $("#divCaseOk").removeClass('active');
        if ($("#divPalletOk").hasClass('active')) $("#divPalletOk").removeClass('active');

        hideItem("#divWrapperRest");
        hideItem("#divCaseRest");
        hideItem("#divPalletRest");

        // проверить наличе ошибки
        if ($("#error_type").val() != "" || $("#error_text").val() != "") {
            showErrorPanel(true);
        }
    };
    //////////////////////////////////////////////////////////////////////////////////////////////
    var getNewStatus = function() {
        var id = $("#id").val();                        
        var url = $("#GetItemAjax").val();

        $.get(url, $.param({ id: id }, true))
            .done(function (data) {
                if (data !== null && data !== '') {

                    analyseNewStatus(data);
                }
            })
        .fail(function () {
            console.log("Cannot get Production Item");
        });
    };
    //////////////////////////////////////////////////////////////////////////////////////////////
    var analyseNewStatus = function (data) {

        // обновить статус на странице
        $("#status").val(data.status);
        $("#status_text").text(data.status_text);
        $("#status_text").removeClass();
        $("#status_text").addClass("control-label status-box ");
        $("#status_text").addClass(data.status_color);

        var status = parseInt(data.status);

        // обновить статус кнопок
        updateButtons(status);

        switch(status)
        {
            case Status.Finished:
                {
                    // финализировать
                    finalize();
                    break;
                }
            case Status.Failed:
                {
                    // показать ошибку
                    showError(data);
                    break;
                }
            default:
                {
                    // обновить данные на странице
                    updateData(data);
                    break;
                }
        }
    };
    //////////////////////////////////////////////////////////////
    var showError = function(data) {
        if (data.error_text != null && data.error_type) {
            $("#error_type").val(data.error_type);
            $("#error_text").html(data.error_text);
            // показать панель с ошибкой
            showErrorPanel(true);
        }
    };
    //////////////////////////////////////////////////////////////
    var updateData = function(data) {
        // скрыть панель с ошибкой
        showErrorPanel(false);

        // sn_ok - printed
        if (data.sn_ok != null) {
            $("#divSnOkValue").html(data.sn_ok);
        } else {
            $("#divSnOkValue").html("-");
        }
                            
        $("#divSnOk div").html(data.sn_ok_percentage);
        $("#divSnOk div").css("width", data.sn_ok_percentage);
        if (!$("#divSnOk").hasClass('active')) {
            $("#divSnOk").addClass('active');
        }

        // sn_packed
        if (data.sn_packed != null) {
            $("#divSnPackedValue").html(data.sn_packed);
        } else {
            $("#divSnPackedValue").html("-");
        }

        $("#divSnPacked div").html(data.sn_packed_percentage);
        $("#divSnPacked div").css("width", data.sn_packed_percentage);
        if (!$("#divSnPacked").hasClass('active')) {
            $("#divSnPacked").addClass('active');
        }

        // sn_nok
        if (data.sn_nok != null) {
            $("#divSnNokValue").html(data.sn_nok);
        } else {
            $("#divSnNokValue").html("-");
        }
                            
        $("#divSnNok div").html(data.sn_nok_percentage);
        $("#divSnNok div").css("width", data.sn_nok_percentage);
        if (!$("#divSnNok").hasClass('active')) {
            $("#divSnNok").addClass('active');
        }

        // sn_unassigned
        if (data.sn_unassigned != null) {
            $("#divSnUnassignedValue").html(data.sn_unassigned);
        } else {
            $("#divSnUnassignedValue").html("-");
        }                            
        $("#divSnUnassigned div").html(data.sn_unassigned_percentage);
        $("#divSnUnassigned div").css("width", data.sn_unassigned_percentage);
        if (!$("#divSnUnassigned").hasClass('active')) {
            $("#divSnUnassigned").addClass('active');
        }

        // aggregation
        $("#divWrapperOkValue").html(data.wrapper_ok_text);
        $("#divWrapperRest").html(data.wrapper_rest);
        $("#divWrapperOk div").html(data.wrapper_ok_percentage);
        $("#divWrapperOk div").css("width", data.wrapper_ok_percentage);
        if (!$("#divWrapperOk").hasClass('active')) {
            $("#divWrapperOk").addClass('active');                            
        }

        // cases                        
        $("#divCaseOkValue").html(data.case_ok_text);
        $("#divCaseRest").html(data.case_rest);
        $("#divCaseOk div").html(data.case_ok_percentage);
        $("#divCaseOk div").css("width", data.case_ok_percentage);
        if (!$("#divCaseOk").hasClass('active')) {
            $("#divCaseOk").addClass('active');                            
        }

        // pallets
        $("#divPalletOkValue").html(data.pallet_ok_text);
        $("#divPalletRest").html(data.pallet_rest);
        $("#divPalletOk div").html(data.pallet_ok_percentage);
        $("#divPalletOk div").css("width", data.pallet_ok_percentage);
        if (!$("#divPalletOk").hasClass('active')) {
            $("#divPalletOk").addClass('active');
        }

        checkStatistics();

    };    
    //////////////////////////////////////////////////////////////
    var btnSaveToCsvClick = function() {
        //сохранение статистики в csv
        $("#btnSaveToCsv").click(function () {
            var batch_id = $("#batch_id").val();
            var url = $("#SaveToCsvAjax").val();
            $.post(url, { batch_id: batch_id })
                .done(function(data) {
                    if (data.fileName != "") {
                        window.location.href = $("#DownloadFile").val() + "/?path=" + data.path;
                    }
                });
        });
    };
    //////////////////////////////////////////////////////////////
    var btnSaveToXlsxClick = function() {
        //сохранение статистики в xlsx
        $("#btnSaveToXlsx").click(function ()
        {
            var url = $("#SaveToXlsxAjax").val();
            var batch_id = $("#batch_id").val();
            $.post(url, { batch_id: batch_id })
                .done(function(data) {
                    if (data.fileName != "") {
                        window.location.href = $("#DownloadFile").val() + "/?path=" + data.path;
                    }
                });
        });
    };    
    //////////////////////////////////////////////////////////////
    var btnStopProductionClick = function () {
        $("#btnStopProduction").click(function () {
            var url = $("#StopProductionAjax").val();
            var id = $("#id").val();

            $.post(url, { id: id })
            .done(function (data) {
                if (data !== null && data !== '') {
                    if (data.Result == true) {
                        $("#status").val(data.status);
                        $("#status_text").text(data.status_text);
                        $("#status_text").removeClass();
                        $("#status_text").addClass("control-label status-box ");
                        $("#status_text").addClass(data.status_color);

                        updateButtons(data.status);
                        
                        toastr.info("Производство №" + id + " завершено");
                    } else {
                        toastr.error(data.Description);
                    }
                }
            })
          .fail(function () {
              toastr.error("Ошибка завершения производства");
          });
        });
    };
    //////////////////////////////////////////////////////////////
    var btnRestartProductionClick = function () {
        $("#btnRestartProduction").click(function () {
            var url = $("#RestartProductionAjax").val();
            var id = $("#id").val();

            $.post(url, { id: id })
            .done(function (data) {
                if (data !== null && data !== '') {
                    if (data.Result == true) {
                        $("#status").val(data.status);
                        $("#status_text").text(data.status_text);
                        $("#status_text").removeClass();
                        $("#status_text").addClass("control-label status-box ");
                        $("#status_text").addClass(data.status_color);

                        updateButtons(data.status);

                        toastr.info("Производство №" + id + " перезапущено");
                    } else {
                        toastr.error(data.Description);
                    }
                }
            })
          .fail(function () {
              toastr.error("Ошибка перезапуска производства");
          });
        });
    };
    //////////////////////////////////////////////////////////////
    var btnInterruptProductionClick = function () {
        $("#btnInterruptProduction").click(function () {
            var url = $("#InterruptProductionAjax").val();
            var id = $("#id").val();

            $.post(url, { id: id })
            .done(function (data) {
                if (data !== null && data !== '') {
                    if (data.Result == true) {
                        $("#status").val(data.status);
                        $("#status_text").text(data.status_text);
                        $("#status_text").removeClass();
                        $("#status_text").addClass("control-label status-box ");
                        $("#status_text").addClass(data.status_color);

                        updateButtons(data.status);

                        toastr.info("Производство №" + id + " приостановлено");

                    } else {
                        toastr.error(data.Description);
                    }
                }
            })
            .fail(function () {
                toastr.error("Ошибка приостановки производства");
            });
        });
    };
    //////////////////////////////////////////////////////////////
    var btnBatchViewClick = function () {
        $("#btnBatchView").click(function () {
            var url = $("#BatchView").val();
            var id = $("#batch_id").val();
            if (id && id != 0) {
                window.location.href = url + "/" + id;
            }
        });
    };
    //////////////////////////////////////////////////////////////
    var btnContinueProductionClick = function () {
        $("#btnContinueProduction").click(function () {
            var url = $("#ContinueProductionAjax").val();
            var id = $("#id").val();

            $.post(url, { id: id })
            .done(function (data) {
                if (data !== null && data !== '') {
                    if (data.Result == true) {
                        $("#status").val(data.status);
                        $("#status_text").text(data.status_text);
                        $("#status_text").removeClass();
                        $("#status_text").addClass("control-label status-box ");
                        $("#status_text").addClass(data.status_color);


                        updateButtons(data.status);

                        toastr.success("Производство №" + id + " возобновлено");
                    } else {
                        toastr.error(data.Description);
                    }
                }
            })
            .fail(function () {
                toastr.error("Ошибка возобновления производства");
            });
        });
    };
    //////////////////////////////////////////////////////////////
    var checkStatus = function (status) {
        if (status == null) {
            status = parseInt($("#status").val());
        }
        switch (status) {
            case Status.Finished:
                {
                    finalize();

                    if (mainLoop) {
                        clearInterval(mainLoop);
                    }

                    break;
                }
            case Status.Failed:
                {
                    showErrorPanel(true);
                    break;
                }
            default:
                {
                    getNewStatus();
                    break;
                }
        }
    };
    ////////////////////////////////////////////////////////////////
    var AddPackage = function (package_type) {
        var url = $("#AddPackageAjax").val();
        var id = $("#id").val();

        $.post(url, { id: id, package_type: package_type })
        .done(function (data) {
            if (data !== null && data !== '') {
                if (data.Result == true) {
                    toastr.info(data.Description);
                } else {
                    toastr.error(data.Description);
                }
            }
        })
        .fail(function () {
            toastr.error("Ошибка возобновления производства");
        });
    };
    ////////////////////////////////////////////////////////////////
    var addWrapperOnClick = function () {
        $("#addWrapper").click(function () {
            AddPackage(PackageType.Wrapper);
        });
    };
    ////////////////////////////////////////////////////////////////
    var addCaseOnClick = function () {
        $("#addCase").click(function () {
            AddPackage(PackageType.Case);
        });
    };
    ////////////////////////////////////////////////////////////////
    var addPalletOnClick = function () {
        $("#addPallet").click(function () {
            AddPackage(PackageType.Pallet);
        });
    };
    ////////////////////////////////////////////////////////////////
    var init = function () {

        // инициализация тултипов
        $('[data-toggle="tooltip"]').tooltip();

        addWrapperOnClick();
        addCaseOnClick();
        addPalletOnClick();

        btnBatchViewClick();
        btnSaveToCsvClick();
        btnSaveToXlsxClick();
        btnStopProductionClick();
        btnInterruptProductionClick();
        btnContinueProductionClick();
        btnRestartProductionClick();

        // свернуть второстепенные панели
        $("#divEquipment .showhide").click();
        $("#divCustomer .showhide").click();
        $("#divSerializationParams .showhide").click();
        $("#divExtraParams .showhide").click();
        $("#divProductionEvents .showhide").click();

        var status = parseInt($("#status").val());

        // проверить статус
        checkStatus(status);

        // обновить статус кнопок
        updateButtons(status);

        // проверка статистики
        checkStatistics();

        // запуск основного цикла проверки статуса
        mainLoop = setInterval(function () {

            checkStatus();
            
        }, 1000);

    };

    return {
        init: init
    };
 

})();
//////////////////////////////////////////////////////////////
$(document).ready(function () {

    ProductionView.init();

});
//////////////////////////////////////////////////////////////