﻿////////////////////////////////////////////////////////////////////////
var dashboardActiveTasksTable = null;
////////////////////////////////////////////////////////////////////////
var DashboardActiveTasksColumns = {
    task_name: 0,
    status_text: 1,
    status_color: 2,
    id: 3
}
///////////////////////////////////////////////////////////////////////
var viewActiveTaskDetails = function (id) {
    if (id != null) {
        var url = $("#ProductionView").val();
        if (url != null) {
            window.location.href = url + "/" + id;
        }
    }
}
/////////////////////////////////////////////////////////////////////
var loadDashboardActiveTasksTable = function () {
    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    if (dashboardActiveTasksTable == null) {

        var url = $("#GetActiveTasksListAjax").val();
        dashboardActiveTasksTable = $('#dashboardActiveTasksTable').dataTable({
            language: {                
                "emptyTable": "Нет активных заданий"
            },
            "ajax": {
                url,
                type: "POST"
            },
            "drawCallback": function( settings ) {
                var array = this.api().rows({ page: 'current' }).data();
 
                // Output the data for the visible rows to the browser's console
                $("#taskCount").html("(" + array.length + ")");
            },
            fixedHeader: false,
            "bSort": false,
            "scrollY": "110px",
            "scrollCollapse": true,
            "bPaginate": false,
            "bInfo": false,
            "bDestroy": false,
            "bFilter": false,
            "bServerSide": true,
            "columnDefs": [
                {
                    "width": "50%",
                    render: function (data, type, full, meta) {
                        return data;
                    },
                    targets: DashboardActiveTasksColumns.task_name
                },
                {
                    "orderable": false,
                    "targets": [DashboardActiveTasksColumns.id],
                    "visible": false,
                    "searchable": false
                },
                {
                    "width": "50%",
                    "orderable": false,
                    "targets": [DashboardActiveTasksColumns.status_text],
                    "searchable": false,
                    render: function (data, type, full, meta) {
                        var color = full[DashboardActiveTasksColumns.status_color];
                        return "<div class='" + color + "'>" + data + "</div>";
                        return data;
                    },
                },
                {
                    "orderable": false,
                    "targets": [DashboardActiveTasksColumns.status_color],
                    "visible": false,
                    "searchable": false
                }
            ]
        });
    } else {
        dashboardActiveTasksTable.api().ajax.reload();
    }
    //////////////////////////////////////////////////////////////////////
    $('#dashboardActiveTasksTable tbody').on('click', 'tr', function () {
        var data = dashboardActiveTasksTable.api().row(this).data();
        var id = data[DashboardActiveTasksColumns.id];

        viewActiveTaskDetails(id);

    });
}
