﻿////////////////////////////////////////////////////////////////////////
var dashboardEventTable = null;
////////////////////////////////////////////////////////////////////////
var DashboardEventColumns = {
    date: 0,
    event_type_color: 1,
    source_type: 2,    
    source_id: 3,
    desctiption: 4
}
///////////////////////////////////////////////////////////////////////
var SourceType = {
    Production: 0,
    Batch: 1,
    Equipment: 2
}
///////////////////////////////////////////////////////////////////////
var viewEventDetails = function (source_type, source_id) {
    if (source_type != null && source_id != null) {
        var url = null;
        if (source_type == SourceType.Production) {
            url = $("#ProductionView").val();
        } else if (source_type == SourceType.Batch) {
            url = $("#BatchView").val();
        } else if (source_type == SourceType.Equipment) {
            url = $("#EquipmentView").val();
        }
        if (url != null) {
            window.location.href = url + "/" + source_id;
        }
    }
}
/////////////////////////////////////////////////////////////////////
var loadDashboardEventTable = function () {
    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');
    
    if (dashboardEventTable == null) {

        var url = $("#GetEventListAjax").val();
        dashboardEventTable = $('#dashboardEventTable').dataTable({
            "ajax": {
                url,
                type: "POST",
                data: {
                }
            },
            "bSort": false,
            "scrollY": "340px",
            "scrollCollapse": true,
            "bPaginate": false,
            "bInfo": false,
            "bDestroy": false,
            "bFilter": false,
            "bServerSide": true,
            "columnDefs": [
                {
                    "width": "30%",
                    render: function (data, type, full, meta) {
                        return data;
                    },
                    targets: DashboardEventColumns.date
                },
                {
                    "orderable": false,
                    "targets": [DashboardEventColumns.event_type_color],
                    "visible": false,
                    "searchable": false
                },
                {
                    "width": "70%",
                    "orderable": false,
                    "targets": [DashboardEventColumns.desctiption],
                    "searchable": false,                    
                    render: function (data, type, full, meta) {
                        var color = full[DashboardEventColumns.event_type_color];
                        return "<div class='" + color + "'>" + data + "</div>";
                        return data;
                    },
                },
                {
                    "orderable": false,
                    "targets": [DashboardEventColumns.source_type],
                    "visible": false,
                    "searchable": false
                },
                {
                    "orderable": false,
                    "targets": [DashboardEventColumns.source_id],
                    "visible": false,
                    "searchable": false
                }                
            ]
        });
    } else {
        dashboardEventTable.api().ajax.reload();
    }

    $('#dashboardEventTable tbody').on('click', 'tr', function () {
        var data = dashboardEventTable.api().row(this).data();
        var source_type = data[DashboardEventColumns.source_type];
        var source_id = data[DashboardEventColumns.source_id];

        viewEventDetails(source_type, source_id);

    });
}
