﻿/////////////////////////////////////////////////////////////////////
var dashboardStatisticsChart = null;
/////////////////////////////////////////////////////////////////////
var loadDashboardStatistics = function () {
    var period = $("#dashboardStatPeriod").val();
    var style = $("#dashboardStatStyle").val();
    var url = $("#GetStatisticsAjax").val();
    if (url != null) {
        $.get(url, { period: period }, function (data) {
            if (data) {

                if (data.produced != null) {
                    $("#producedStat").html(data.produced);
                } else {
                    $("#producedStat").html(0);
                }

                if (data.rejected != null) {
                    $("#rejectedStat").html(data.rejected);
                } else {
                    $("#rejectedStat").html(0);
                }

                if (data.retrieved != null) {
                    $("#retrievedStat").html(data.retrieved);
                } else {
                    $("#retrievedStat").html(data.retrieved);
                }

                if (data.delivered != null) {
                    $("#deliveredStat").html(data.delivered);
                } else {
                    $("#deliveredStat").html(0);
                }
                
                var lineData = {
                    labels: data.labels,
                    datasets: [
                        {
                            label: "Производство",
                            fillColor: "rgba(52, 152, 219, 0.5)",
                            strokeColor: "rgba(52, 152, 219,0.7)",
                            pointColor: "rgba(52, 152, 219,1)",
                            pointStrokeColor: "#fff",
                            pointHighlightFill: "#fff",
                            pointHighlightStroke: "rgba(26,179,148,1)",
                            data: data.values
                        }
                    ]
                };

                var lineOptions = {
                    scaleShowGridLines: true,
                    scaleGridLineColor: "rgba(0,0,0,.05)",
                    scaleGridLineWidth: 1,
                    bezierCurve: true,
                    bezierCurveTension: 0.4,
                    pointDot: true,
                    pointDotRadius: 4,
                    pointDotStrokeWidth: 1,
                    pointHitDetectionRadius: 20,
                    datasetStroke: true,
                    datasetStrokeWidth: 1,
                    datasetFill: true,
                    responsive: true
                };


                var ctx = document.getElementById("dashboardStatisticsChart").getContext("2d");

                if (dashboardStatisticsChart != null) {
                    dashboardStatisticsChart.destroy();
                }
          
                if (style == StatStyle.bar) {
                    dashboardStatisticsChart = new Chart(ctx).Bar(lineData, lineOptions);
                } else if (style == StatStyle.linear) {
                    dashboardStatisticsChart = new Chart(ctx).Line(lineData, lineOptions);
                }
                
            }
        });
    }
}
$(function () {

    $("dashboardStatPeriod select").val(Period.month);

    


});
//$(function () {

//    var lineData = {
//        labels: ["January", "February", "March", "April", "May", "June", "July"],
//        datasets: [
//            {
//                label: "Example dataset",
//                fillColor: "rgba(98,203,49,0.5)",
//                strokeColor: "rgba(98,203,49,0.7)",
//                pointColor: "rgba(98,203,49,1)",
//                pointStrokeColor: "#fff",
//                pointHighlightFill: "#fff",
//                pointHighlightStroke: "rgba(26,179,148,1)",
//                data: [16, 32, 18, 26, 42, 33, 44]
//            }
//        ]
//    };

//    var lineOptions = {
//        scaleShowGridLines: true,
//        scaleGridLineColor: "rgba(0,0,0,.05)",
//        scaleGridLineWidth: 1,
//        bezierCurve: true,
//        bezierCurveTension: 0.4,
//        pointDot: true,
//        pointDotRadius: 4,
//        pointDotStrokeWidth: 1,
//        pointHitDetectionRadius: 20,
//        datasetStroke: true,
//        datasetStrokeWidth: 1,
//        datasetFill: true,
//        responsive: true
//    };


//    var ctx = document.getElementById("lineOptions").getContext("2d");
//    ctx.canvas.height = 100;

//    var myNewChart = new Chart(ctx).Line(lineData, lineOptions);

//});