﻿/////////////////////////////////////////////////////////////////////////////////////////////////////
var MedicineColumns = {
    gtin: 0,
    name: 1,
    shelf_life: 2,
    id: 3
}
/////////////////////////////////////////////////////////////////////////////////////////////////////
$(function () {

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    $('#medicineListModal').on('hidden.bs.modal', function () {
        popUpHideAll("#medicineListModal");
    });

    $('#btnMedicine').on('click', function () {

        popUpShowProgress("#medicineListModal");

        $('#medicineListModal').modal('show');

        var url = $("#GetMedicineListAjax").val();

        var table = $('#medicineTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                type: "post",
                complete: function () {
                    if (table.api().data().count()) {
                        $("#medicineListModal .modal-dialog").stop(true, true);
                        $("#medicineListModal .modal-dialog").animate({ "width": "800px" }, 300, 'linear');
                        popUpShowResults("#medicineListModal");
                    } else {
                        popUpShowError("#medicineListModal", 'Список пуст');
                    }
                }
            },
            "autoWidth": false,
            "bDestroy": true,
            "bFilter": false,
            "bPaginate": false,
            "bInfo": false,
            "bServerSide": true,
            "bProcessing": false,
            "order": [[0, "asc"]],
            "columnDefs": [
                {
                    "width": "20%",
                    "orderable": false,
                    "targets": -1,
                    "data": null,
                    render: function (data, type, full, meta) {
                        return "<div class=\"dropdown hor-mid\">" +
                                    "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Выбрать\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                    "</a>" +
                                "</div>";
                    }
                }
            ]
        });

        $('#medicineTable tbody').on('click', 'a', function () {
            var data = table.api().row($(this).parents('tr')).data();
            
            var gtin = data[MedicineColumns.gtin];            

            $('#divGtin2article #product_gtin').val(gtin);

            $('#medicineListModal').modal('hide');

        });
    });

    $('#medicineListModal').on('hidden.bs.modal', function () {
        $("#medicineListModal .modal-dialog").stop(true, true);
        $("#medicineListModal .modal-dialog").animate({ "width": "500px" }, 100, 'linear');
    });

});