﻿////////////////////////////////////////////////////////////////////////
var eventTable = null;
////////////////////////////////////////////////////////////////////////
var EventColumns = {
    date: 0,
    event_type: 1,
    event_type_text: 2,
    event_type_color: 3,
    user_id: 4,
    user_name: 5,
    source_type: 6,
    source_type_text: 7,
    source_id: 8,
    desctiption: 9,
    action: 10
}
///////////////////////////////////////////////////////////////////////
var SourceType = {
    Production: 0,
    Batch: 1,
    Equipment: 2
}
///////////////////////////////////////////////////////////////////////
var viewDetails = function (source_type, source_id) {
    if (source_type != null && source_id != null) {
        var url = null;
        if (source_type == SourceType.Production) {
            url = $("#ProductionView").val();
        } else if (source_type == SourceType.Batch) {
            url = $("#BatchView").val();
        } else if (source_type == SourceType.Equipment) {
            url = $("#EquipmentView").val();
        }
        if (url != null) {
            window.location.href = url + "/" + source_id;
        }        
    }
}
/////////////////////////////////////////////////////////////////////
var showHideFilter = function () {
    var show_filter = $('#show_filter').val();
    if (show_filter == 'true') {
        $('#divFilter').show();
    } else {
        $('#divFilter').hide();
    }

    loadEventTable(null, null, null);
}
/////////////////////////////////////////////////////////////////////
var loadEventTable = function (filter_date, event_type, description) {
    // очистить таблицу
    if (eventTable != null) {
        eventTable.api().clear();
    }

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');
    var url = $("#GetListAjax").val();
        eventTable = $('#eventTable').dataTable({
            language: {
                "url": $("#lang").val()
            },
            "ajax": {
                url,
                type: "POST",
                data: {
                    filter_date: filter_date,
                    event_type: event_type,
                    description: description
                }
            },
            "bDestroy": true,
            "bFilter": false,
            "bServerSide": true,
            "bProcessing": true,
            "order": [[0, "desc"]],
            "columnDefs": [
                {
                    "width": "120",
                    render: function(data, type, full, meta) {
                        return "<div class='text-nowrap'>" + data + "</div>";
                    },
                    targets: EventColumns.date
                },
                {
                    "width": "100",
                    render: function(data, type, full, meta) {
                        var color = full[EventColumns.event_type_color];
                        return "<div class='list-status-box " + color + "'>" + data + "</div>";
                    },
                    targets: EventColumns.event_type_text
                },
                {
                    "width": "100",
                    render: function (data, type, full, meta) {
                        var user = full[EventColumns.user_name];
                        return `<div class='text-nowrap'>${user}</div>`;
                    },
                    targets: EventColumns.user_name
                },
                {
                    "visible": false,
                    "searchable": false,
                    render: function(data, type, full, meta) {
                        var user_id = full[EventColumns.user_id];
                        return `<div class='text-nowrap'>${user_id}</div>`;
                    },
                    targets: EventColumns.user_id
                },
                {
                    "width": "100",
                    render: function(data, type, full, meta) {
                        return "<div class='text-nowrap'>" + data + "</div>";
                    },
                    targets: EventColumns.source_type_text
                },
                {
                    "targets": [EventColumns.user_id],
                    "visible": false,
                    "searchable": false
                },
                {
                    "targets": [EventColumns.event_type],
                    "visible": false,
                    "searchable": false
                },
                {
                    "targets": [EventColumns.event_type_color],
                    "visible": false,
                    "searchable": false
                },
                {
                    "targets": [EventColumns.source_type],
                    "visible": false,
                    "searchable": false
                },
                {
                    "targets": [EventColumns.source_id],
                    "visible": false,
                    "searchable": false
                },
                {
                "visible":false,
                "orderable": false,
                "targets": -1,
                "data": null,
                render: function (data, type, full, meta) {
                    return "<div class=\"dropdown hor-mid\">" +
                                    "<a class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Действие\" href=\"#\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-hand-pointer-o table-icons-big\"></i>" +
                                    "</a>" +
                                    "<ul class=\"dropdown-menu hdropdown notification animated flipInX extra-margin-left-xl\">" +
                                        "<li>" +
                                            "<a onclick=\"viewDetails(" + data[EventColumns.source_type] + "," + data[EventColumns.source_id] + ")\" class=\"m-r-sm\" data-toggle=\"tooltip\" data-placement=\"bottom\" title=\"Подробная информация\">" +
                                                "<i class=\"fa fa-eye table_icons action-menu-item\"></i>Детализация" +
                                            "</a>" +
                                        "</li>" +
                                    "</ul>" +
                                "</div>";
                }
            }
        ]
    });
}
////////////////////////////////////////////////////////////////////////
$(function () {

    $("#filter_date").datepicker({
        format: 'dd.mm.yyyy',
        language: 'ru'
    });

    showHideFilter();

    ////////////////////////////////////////////////////////////////////////
    $("#btnFilter").click(function () {
        if ($('#show_filter').val() == 'true') {
            $('#show_filter').val('false');
        } else {
            $('#show_filter').val('true');
        }

        showHideFilter();

        $('#description').val("");        

    });
    ////////////////////////////////////////////////////////////////////////
    $("#btnApplyFilter").click(function () {
        var description = $('#description').val();
        var event_type = $('#event_type :selected').val();
        var filter_date = $('#filter_date').val();

        loadEventTable(filter_date, event_type, description);
    });
    ////////////////////////////////////////////////////////////////////////
    $("#btnClearEvents").click(function () {
        $('#deleteModal #message').html('<h3> Удалить события? </h3>');
        $('#deleteModal').modal('show');
    });

    ////////////////////////////////////////////////////////////////
    $('#deleteModal #btnCloseModal').on('click', function () {
        $('#deleteModal').modal('hide');
    });

    ////////////////////////////////////////////////////////////////
    $('#deleteModal #btnDeleteModal').on('click', function () {        
        var url = $('#DeleteListAjax').val();
        var description = $('#description').val();
        var event_type = $('#event_type :selected').val();
        var filter_date = $('#filter_date').val();

        $.post(url,
                {
                    filter_date: filter_date,
                    event_type: event_type,
                    description: description
                })
            .done(function() {
                if (eventTable) {
                    eventTable.api().ajax.reload();
                }

                $('#deleteModal').modal('hide');
            });
    });
    $("#btnSaveEventsToXlsx").click(function () {
        var url = $("#SaveToXlsxAjax").val();
        $.post(url)
            .done(function (data) {
                if (data.fileName != "") {
                    window.location.href = $("#DownloadFile").val() + "/?path=" + data.path;
                }
            });
    });
});