﻿
var EquipmentColumns = {
    name: 0,
    type_text: 1,
    status_text: 2,
    status_color: 3,
    order: 4,
    order_status: 5,
    action: 6
}

$(function () {

    $.fn.dataTable.moment('DD.MM.YYYY HH:mm:ss');

    var url = $("#GetListAjax").val();

    var table = $('#equipmentTable').dataTable({
        language: {
            "url": $("#lang").val()
        },
        "sAjaxSource": url,
        "bServerSide": true,
        "bProcessing": true,
        "order": [[0, "asc"]],
        "columnDefs": [
            {
                "targets": EquipmentColumns.status_color,
                visible: false
            },
            {
                render: function (data, type, full, meta) {
                    var status_color = full[EquipmentColumns.status_color];
                    return "<div class='" + status_color + "'>" + data + "</div>";
                },
                targets: EquipmentColumns.status_text
            },
            {
                "orderable": false,
                "targets": -1,
                "data": null,
                render: function (data, type, full, meta) {
                    var url = $("#ViewUrl").val() + "/" + data[EquipmentColumns.action];
                    return "<div class=\"dropdown hor-mid\">" +
                                    "<a href='" + url + "' onClick=\"window.location.href ='" + url + "'\" class=\"dropdown-toggle icon-box infont\" data-placement=\"bottom\" title=\"Детализация\" data-toggle=\"dropdown\">" +
                                        "<i class=\"fa fa-eye table-icons-big\"></i>" +
                                    "</a>" +
                                "</div>";
                }
            }
        ],
        initComplete: function () {
            var api = this.api();
            $('#equipmentTable input')
                .off('.DT')
                .on('keyup.DT', function (e) {
                    if (e.keyCode === 13 || this.value.length === 0) {
                        api.search(this.value).draw();
                    }
                });
        }
    });

});