﻿// Handle print button
$("#btnPrint").click(function () {
    var url = $("#GetPrinterSettings").val();

    $.post(url)
            .done(function (response) {

                // set printer list
                var innerhtml = "<select class=\"form-control\" id=\"printers\" name=\"printers\">";
                for (var index = 0; index < response.printers.length ; index++) {
                    innerhtml += "<option value=\"" + response.printers[index][0] + "\">" + response.printers[index][1] + "</option>";
                }
                innerhtml += "</select>";

                document.getElementById("printerList").innerHTML = innerhtml;

                // set template list
                innerhtml = "<select class=\"form-control\" id=\"templates\" name=\"templates\">";
                for (var index = 0; index < response.templates.length ; index++) {
                    innerhtml += "<option value=\"" + response.templates[index][0] + "\">" + response.templates[index][1] + "</option>";
                }
                innerhtml += "</select>";

                document.getElementById("templateList").innerHTML = innerhtml;

                $('#printSettingsModal').modal('show');
            });
});

// Handle modal close button
$('#printSettingsModal #btnCloseModal').on('click', function () {
    $('#printSettingsModal').modal('hide');
});

// Handle modal print button
$('#printSettingsModal #btnPrintModal').on('click', function () {
    $('#printSettingsModal').modal('hide');

    // get selected printer
    var printers = document.getElementById("printers");
    var printer_id = parseInt(printers.options[printers.selectedIndex].value);

    // get selected template
    var templates = document.getElementById("templates");
    var template_id = parseInt(templates.options[templates.selectedIndex].value);

    // get item id
    var item_id = document.getElementById("item_id").value;

    // send data for print label
    var url = $("#PrintLabelAjax").val();

    $.post(url, {
        printer_id: printer_id,
        template_id: template_id,
        item_id: item_id
    })
        .done(function (data) {
            if (data != null && data != '') {
                if (data.Result == true) {
                    toastr.info(data.Description, "Печать этикетки");
                } else {
                    toastr.error(data.Description, "Печать этикетки");
                }
            }
        })
        .fail(function () {
            // todo
        });
});